<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
<!-- 2021-12-03 Fri 15:43 -->
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1" />
<title>Managing Dotfiles With Style With rcm</title>
<meta name="author" content="dt" />
<meta name="description" content="Guest Articles - Managing Dotfiles With Style With rcm
Header" />
<meta name="generator" content="Org Mode" />
<style>
  #content { max-width: 60em; margin: auto; }
  .title  { text-align: center;
             margin-bottom: .2em; }
  .subtitle { text-align: center;
              font-size: medium;
              font-weight: bold;
              margin-top:0; }
  .todo   { font-family: monospace; color: red; }
  .done   { font-family: monospace; color: green; }
  .priority { font-family: monospace; color: orange; }
  .tag    { background-color: #eee; font-family: monospace;
            padding: 2px; font-size: 80%; font-weight: normal; }
  .timestamp { color: #bebebe; }
  .timestamp-kwd { color: #5f9ea0; }
  .org-right  { margin-left: auto; margin-right: 0px;  text-align: right; }
  .org-left   { margin-left: 0px;  margin-right: auto; text-align: left; }
  .org-center { margin-left: auto; margin-right: auto; text-align: center; }
  .underline { text-decoration: underline; }
  #postamble p, #preamble p { font-size: 90%; margin: .2em; }
  p.verse { margin-left: 3%; }
  pre {
    border: 1px solid #e6e6e6;
    border-radius: 3px;
    background-color: #f2f2f2;
    padding: 8pt;
    font-family: monospace;
    overflow: auto;
    margin: 1.2em;
  }
  pre.src {
    position: relative;
    overflow: auto;
  }
  pre.src:before {
    display: none;
    position: absolute;
    top: -8px;
    right: 12px;
    padding: 3px;
    color: #555;
    background-color: #f2f2f299;
  }
  pre.src:hover:before { display: inline; margin-top: 14px;}
  /* Languages per Org manual */
  pre.src-asymptote:before { content: 'Asymptote'; }
  pre.src-awk:before { content: 'Awk'; }
  pre.src-authinfo::before { content: 'Authinfo'; }
  pre.src-C:before { content: 'C'; }
  /* pre.src-C++ doesn't work in CSS */
  pre.src-clojure:before { content: 'Clojure'; }
  pre.src-css:before { content: 'CSS'; }
  pre.src-D:before { content: 'D'; }
  pre.src-ditaa:before { content: 'ditaa'; }
  pre.src-dot:before { content: 'Graphviz'; }
  pre.src-calc:before { content: 'Emacs Calc'; }
  pre.src-emacs-lisp:before { content: 'Emacs Lisp'; }
  pre.src-fortran:before { content: 'Fortran'; }
  pre.src-gnuplot:before { content: 'gnuplot'; }
  pre.src-haskell:before { content: 'Haskell'; }
  pre.src-hledger:before { content: 'hledger'; }
  pre.src-java:before { content: 'Java'; }
  pre.src-js:before { content: 'Javascript'; }
  pre.src-latex:before { content: 'LaTeX'; }
  pre.src-ledger:before { content: 'Ledger'; }
  pre.src-lisp:before { content: 'Lisp'; }
  pre.src-lilypond:before { content: 'Lilypond'; }
  pre.src-lua:before { content: 'Lua'; }
  pre.src-matlab:before { content: 'MATLAB'; }
  pre.src-mscgen:before { content: 'Mscgen'; }
  pre.src-ocaml:before { content: 'Objective Caml'; }
  pre.src-octave:before { content: 'Octave'; }
  pre.src-org:before { content: 'Org mode'; }
  pre.src-oz:before { content: 'OZ'; }
  pre.src-plantuml:before { content: 'Plantuml'; }
  pre.src-processing:before { content: 'Processing.js'; }
  pre.src-python:before { content: 'Python'; }
  pre.src-R:before { content: 'R'; }
  pre.src-ruby:before { content: 'Ruby'; }
  pre.src-sass:before { content: 'Sass'; }
  pre.src-scheme:before { content: 'Scheme'; }
  pre.src-screen:before { content: 'Gnu Screen'; }
  pre.src-sed:before { content: 'Sed'; }
  pre.src-sh:before { content: 'shell'; }
  pre.src-sql:before { content: 'SQL'; }
  pre.src-sqlite:before { content: 'SQLite'; }
  /* additional languages in org.el's org-babel-load-languages alist */
  pre.src-forth:before { content: 'Forth'; }
  pre.src-io:before { content: 'IO'; }
  pre.src-J:before { content: 'J'; }
  pre.src-makefile:before { content: 'Makefile'; }
  pre.src-maxima:before { content: 'Maxima'; }
  pre.src-perl:before { content: 'Perl'; }
  pre.src-picolisp:before { content: 'Pico Lisp'; }
  pre.src-scala:before { content: 'Scala'; }
  pre.src-shell:before { content: 'Shell Script'; }
  pre.src-ebnf2ps:before { content: 'ebfn2ps'; }
  /* additional language identifiers per "defun org-babel-execute"
       in ob-*.el */
  pre.src-cpp:before  { content: 'C++'; }
  pre.src-abc:before  { content: 'ABC'; }
  pre.src-coq:before  { content: 'Coq'; }
  pre.src-groovy:before  { content: 'Groovy'; }
  /* additional language identifiers from org-babel-shell-names in
     ob-shell.el: ob-shell is the only babel language using a lambda to put
     the execution function name together. */
  pre.src-bash:before  { content: 'bash'; }
  pre.src-csh:before  { content: 'csh'; }
  pre.src-ash:before  { content: 'ash'; }
  pre.src-dash:before  { content: 'dash'; }
  pre.src-ksh:before  { content: 'ksh'; }
  pre.src-mksh:before  { content: 'mksh'; }
  pre.src-posh:before  { content: 'posh'; }
  /* Additional Emacs modes also supported by the LaTeX listings package */
  pre.src-ada:before { content: 'Ada'; }
  pre.src-asm:before { content: 'Assembler'; }
  pre.src-caml:before { content: 'Caml'; }
  pre.src-delphi:before { content: 'Delphi'; }
  pre.src-html:before { content: 'HTML'; }
  pre.src-idl:before { content: 'IDL'; }
  pre.src-mercury:before { content: 'Mercury'; }
  pre.src-metapost:before { content: 'MetaPost'; }
  pre.src-modula-2:before { content: 'Modula-2'; }
  pre.src-pascal:before { content: 'Pascal'; }
  pre.src-ps:before { content: 'PostScript'; }
  pre.src-prolog:before { content: 'Prolog'; }
  pre.src-simula:before { content: 'Simula'; }
  pre.src-tcl:before { content: 'tcl'; }
  pre.src-tex:before { content: 'TeX'; }
  pre.src-plain-tex:before { content: 'Plain TeX'; }
  pre.src-verilog:before { content: 'Verilog'; }
  pre.src-vhdl:before { content: 'VHDL'; }
  pre.src-xml:before { content: 'XML'; }
  pre.src-nxml:before { content: 'XML'; }
  /* add a generic configuration mode; LaTeX export needs an additional
     (add-to-list 'org-latex-listings-langs '(conf " ")) in .emacs */
  pre.src-conf:before { content: 'Configuration File'; }

  table { border-collapse:collapse; }
  caption.t-above { caption-side: top; }
  caption.t-bottom { caption-side: bottom; }
  td, th { vertical-align:top;  }
  th.org-right  { text-align: center;  }
  th.org-left   { text-align: center;   }
  th.org-center { text-align: center; }
  td.org-right  { text-align: right;  }
  td.org-left   { text-align: left;   }
  td.org-center { text-align: center; }
  dt { font-weight: bold; }
  .footpara { display: inline; }
  .footdef  { margin-bottom: 1em; }
  .figure { padding: 1em; }
  .figure p { text-align: center; }
  .equation-container {
    display: table;
    text-align: center;
    width: 100%;
  }
  .equation {
    vertical-align: middle;
  }
  .equation-label {
    display: table-cell;
    text-align: right;
    vertical-align: middle;
  }
  .inlinetask {
    padding: 10px;
    border: 2px solid gray;
    margin: 10px;
    background: #ffffcc;
  }
  #org-div-home-and-up
   { text-align: right; font-size: 70%; white-space: nowrap; }
  textarea { overflow-x: auto; }
  .linenr { font-size: smaller }
  .code-highlighted { background-color: #ffff00; }
  .org-info-js_info-navigation { border-style: none; }
  #org-info-js_console-label
    { font-size: 10px; font-weight: bold; white-space: nowrap; }
  .org-info-js_search-highlight
    { background-color: #ffff00; color: #000000; font-weight: bold; }
  .org-svg { width: 90%; }
</style>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
</head>
<body>
<div id="content" class="content">
<h1 class="title">Managing Dotfiles With Style With rcm</h1>
<div id="table-of-contents" role="doc-toc">
<h2>Table of Contents</h2>
<div id="text-table-of-contents" role="doc-toc">
<ul>
<li><a href="#org8025f07">Managing Dotfiles With Style With rcm</a></li>
<li><a href="#orge5e0ba4">Introduction</a></li>
<li><a href="#org9a73268">Usage</a></li>
<li><a href="#orgbe04480">Backing up your .dotfiles folder</a></li>
<li><a href="#orge688219">Advanced (cool) features</a></li>
<li><a href="#orgc967cf1">Undotted files and directories</a></li>
<li><a href="#org3461266">Conclusion</a></li>
<li><a href="#org35b6faa">Links</a></li>
</ul>
</div>
</div>
<table border="2" cellspacing="0" cellpadding="6" rules="groups" frame="hsides">


<colgroup>
<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />
</colgroup>
<tbody>
<tr>
<td class="org-left"><a href="../index.html">Home</a></td>
<td class="org-left"><a href="../dtos/index.html">DTOS</a></td>
<td class="org-left"><a href="../kb/index.html">Knowledge Base</a></td>
<td class="org-left"><a href="../community/index.html">Community</a></td>
<td class="org-left"><a href="../contribute/index.html">Contribute</a></td>
<td class="org-left"><a href="../support/index.html">Support DT&rsquo;s Work</a></td>
</tr>
</tbody>
</table>

<div id="outline-container-org8025f07" class="outline-2">
<h2 id="org8025f07">Managing Dotfiles With Style With rcm</h2>
<div class="outline-text-2" id="text-org8025f07">
<p>
<i>By Ronnie Nissan at April 23, 2020</i>
</p>
</div>
</div>

<div id="outline-container-orge5e0ba4" class="outline-2">
<h2 id="orge5e0ba4">Introduction</h2>
<div class="outline-text-2" id="text-orge5e0ba4">
<p>
rcm is a dotfles (rc files) management tool that consists of four programs, rcup, rcdn, mkrc and lsrc. It is open source, and is maintained and funded by thoughtbot, inc.
</p>

<p>
I used to copy all my files to a dotfiles folder in my home directory, then use GNU/stow to make all the symlinks and it worked fine, until I found rcm and my dotfiles game was on a higher level immediately. Using rcm is just fast and intuitive. rcm is available for linux, BSD and MacOs, and you can find how to install it on your system here.
</p>
</div>
</div>

<div id="outline-container-org9a73268" class="outline-2">
<h2 id="org9a73268">Usage</h2>
<div class="outline-text-2" id="text-org9a73268">
<p>
If you are just starting to backup your dotfiles and don&rsquo;t have a default directory for them, then you can start away immediately by running:
</p>

<pre class="example" id="orgdf5677a">
mkrc -v &lt;path to the file or directory you want to backup&gt;
</pre>

<p>
This will creat a .dotfiles folder in your home directory, and will mv the disered file or directory to it, then it will symlink all the files to where they were moved from. For example, if you want to add your .bashrc to the list, you&rsquo;ll do the following:
</p>

<pre class="example" id="org587807b">
mkrc -v ~/.bashrc
</pre>

<p>
The output of the above command will be:
</p>

<pre class="example" id="org6e09cd2">
Moving...
'/home/$USER/.bashrc' -&gt; '/home/$USER/.dotfiles/.bashrc'
Linking...
'/home/$USER/.dotfiles/.bashrc' -&gt; '/home/$USER/.bashrc'
</pre>

<p>
Now if you want to list the available dotfiles in your .dotfiles directory you type lsrc the results will be:
</p>

<pre class="example" id="org8af3e81">
/home/$USER/.bashrc:/home/ron/.dotfiles/bashrc
</pre>

<p>
In your case, where the path before the &ldquo;:&rdquo; is the symlinks location and the path after : is the file in your .dotfiles directory.
</p>

<p>
The program that does all the magic of creates directories and symlinks your files is rcup, it installs and updates your dotfiles. To install or update all the dotfiles you run rcup by itself, but you can specify a file, or directory as will, for example to only install your .bashrc file you type:
</p>

<pre class="example" id="org545dda7">
rcup -v .bashrc
</pre>

<p>
The result of will be:
</p>

<pre class="example" id="orgcef5530">
'/home/$USER/.dotfiles/.bashrc' -&gt; '/home/$USER/.bashrc'
</pre>

<p>
To remove a symlink you use rcdn which will remove all symlinks managed by rcm, you can control this even further by specifying a file or list of files or a directory using the -d flag. Notice that the file will not be removed from your .dotfiles directory and only the symlink will be removed. If you want to restore the symlink you can do that with rcup &lt;filename&gt;. All the above applies to directories as will.
</p>
</div>
</div>

<div id="outline-container-orgbe04480" class="outline-2">
<h2 id="orgbe04480">Backing up your .dotfiles folder</h2>
<div class="outline-text-2" id="text-orgbe04480">
<p>
The best way to backup your dotfiles is to use git, and push them either to Github or Gitlab. To do this you&rsquo;ll first need to make a repository on your Github or Gitlab named “.dotifles” and intialize it with a readme file. Then cd yo your .dotfiles directory and do the follwoing
</p>

<pre class="example" id="org596e01e">
git init
git add . #stage all files inside current git directory
git commit -m "intial commit" #commit the staged changed and add a commit message
git add remote origin &lt;link to your remote repository #add your remote repository
#then push everything to your remote repository with
git push origin master
</pre>

<p>
Now whenever you need to reinstall all your dotfiles all you have to do is clone the remote repository to your home folder then run rcup anywhere from the terminal.
</p>
</div>
</div>

<div id="outline-container-orge688219" class="outline-2">
<h2 id="orge688219">Advanced (cool) features</h2>
<div class="outline-text-2" id="text-orge688219">
<p>
If you already have a dotfiles firectory and you want to use that instead of creating a new one, that is possible using ~/.rcrc file which is the config file of rcm and is sourced by all the other programs in the rcm tools suit. To change the default .dotfiles directory you add this line to your .rcrc
</p>

<pre class="example" id="orgd88f377">
DOTFILES_DIRS="/path/to/your/dotfiles/directory"
</pre>

<p>
But please note that your dotfiles directory must be organized correctly, meaning that the root of your .dotfiles directory is considered your $HOME directory. So if you are an bspwm user for example, you should have “config/bspwm/bspwmrc” inside of your .dotfiles directory so that rcup can symlink it to the correct location which is &ldquo;$HOME/.config/bspwm/bspwmrc&rdquo;. Also not that .config is not dotted inside your .dotfiles directory, as rcup adds the dots when it makes the symlinks.
</p>

<p>
Another very amazing feature in rcm is tags. Quoting the official documentation:
</p>

<blockquote>
<p>
If you share the dotfiles directory between people, you may end up with some irrelevant or even incorrect rc files. For example, you may have a .zshrc while your other contributor has a .bashrc. This situation can be handled with tags.
</p>
</blockquote>

<p>
To do that you have to create to directory inside your .dotfiles that starts with tag-, here you should create two, one called tag-bash and another called tag-zsh, then move your .zshrc to your tag-zsh directory using mkrc.
</p>

<pre class="example" id="orgc8e8483">
mkrc -t zsh .zshrc
#and your bash rc with
mkrc -t bash .bash
</pre>

<p>
Now whenever you are using your computer that runs zsh and you are installing or updating your dotfiles you must type:
</p>

<pre class="example" id="org9884dd8">
rcup -t zsh
</pre>

<p>
And this will install your .zshrc to your system, and whenever on your other computer that runs bash, you replace -t zsh with -t bash. You can set your default tags the TAGS variable inside your .rcrc.
</p>
</div>
</div>

<div id="outline-container-orgc967cf1" class="outline-2">
<h2 id="orgc967cf1">Undotted files and directories</h2>
<div class="outline-text-2" id="text-orgc967cf1">
<p>
If you have lets say, your Scripts directory in your home folder, and you add it to the list of dotfiles managed by rcm, the directory will be prefixed with a .making it hidden. If you want to exclude a file or directory from this behavior, you have to options. The first is to use the -U flag when adding the file or directory. For example&#x2026;
</p>

<pre class="example" id="org4935ba6">
mkrc -U ~/Scripts
</pre>

<p>
Or you can add the file or directory to the UNDOTTED variable in your .rcrc.
</p>
</div>
</div>

<div id="outline-container-org3461266" class="outline-2">
<h2 id="org3461266">Conclusion</h2>
<div class="outline-text-2" id="text-org3461266">
<p>
As you can see from the examples above, rcm is the way to go if you want to manage your dotfiles with style, it is powerful, easy to use and configure, and I hope more people will use it and contribute to it. rcm has many more features and capabilities that I didn&rsquo;t talk about in this post, if you want to learn more about rcm, head to it&rsquo;s official documentation which is very detailed and clean. You can also add the -h flag to any of the four rcm programs to get a quick help on the terminal.
</p>
</div>
</div>

<div id="outline-container-org35b6faa" class="outline-2">
<h2 id="org35b6faa">Links</h2>
<div class="outline-text-2" id="text-org35b6faa">
<ul class="org-ul">
<li><a href="https://thoughtbot.github.io/rcm/rcm.7.html">RCM Documentation</a></li>
</ul>
</div>
</div>
</div>
<div id="postamble" class="status">
<p class="author">Author: dt</p>
<p class="date">Created: 2021-12-03 Fri 15:43</p>
</div>
</body>
</html>
